Subject: Re: TCP checksum error on local device

From: Kristof Provost <[email-masked]>
Date: Wed, 9 Jul 2008 15:10:20 +0000

On 2008-07-09 16:34:32 (+0200), Kevin Spiteri <[email-masked]> wrote:
> When I send TCP data from localhost to localhost (either on 127.0.0.1
> or on the public IP of the machine), the TCP checksum is wrong.
> 
I suspect this is intended and expected behaviour. The checksum is quite
useless as the packet never travels over the network and can't be
corrupted. 

The transmit code in net/ipv4/ip_output.c seems to mark packets for the
loopback interface with CHECKSUM_UNNECESSARY.

I guess the connection over loopback still carries the data like you'd
expect right?

Kristof